# stdlib
require "digest/md5"
require "shellwords"


class Dmux

  VERSION = "0.0.1"


  def initialize app
    @app = app.strip

    if @app.empty?
      $stderr.puts "USAGE: dmux <command>"
      exit 1
    end
  end


  def run
    exists? && attach || create
  end


  protected


  def tmux cmd
    "tmux -L dmux #{cmd}"
  end


  def sid
    @sid ||= Digest::MD5.hexdigest(@app).shellescape
  end


  def app
    @app.shellescape
  end


  def cfg
    File.expand_path("../dmux.conf", __FILE__).shellescape
  end


  def exists?
    system tmux "has -t #{sid} 2>/dev/null"
  end


  def attach
    exec tmux "attach -t #{sid}"
  end


  def create
    exec tmux "new -d -A -s #{sid} #{app} \\; source #{cfg} \\; attach"
  end

end
